Index: branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service_internal.c
===================================================================
--- branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service_internal.c	(revision 530)
+++ branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service_internal.c	(revision 531)
@@ -2605,96 +3164,123 @@
 	 * cf. parseBoundingBox
 	 */
-	if(strcasecmp(tmpInputs->format,"BoundingBoxData")==0){
-	  maps* tmpI=getMaps(*out,tmpInputs->name);
-	  if(tmpI!=NULL){
-	    map* tmpV=getMap(tmpI->content,"value");
-	    if(tmpV!=NULL){
-	      char *tmpVS=strdup(tmpV->value);
-	      map* tmp=parseBoundingBox(tmpVS);
-	      free(tmpVS);
-	      map* tmpC=tmp;
-	      while(tmpC!=NULL){
-		addToMap(tmpMaps->content,tmpC->name,tmpC->value);
-		tmpC=tmpC->next;
-	      }
-	      freeMap(&tmp);
-	      free(tmp);
-	    }
-	  }
-	}
-      }
-
-      if(tmpIoType!=NULL){
-	map* tmpContent=tmpIoType->content;
-	map* cval=NULL;
-	int hasPassed=-1;
-	while(tmpContent!=NULL){
-	  if((cval=getMap(tmpMaps->content,tmpContent->name))==NULL){
+              if (strcasecmp (tmpInputs->format, "BoundingBoxData") == 0)
+                {
+                  maps *tmpI = getMaps (*out, tmpInputs->name);
+                  if (tmpI != NULL)
+                    {
+                      map *tmpV = getMap (tmpI->content, "value");
+                      if (tmpV != NULL)
+                        {
+                          char *tmpVS = strdup (tmpV->value);
+                          map *tmp = parseBoundingBox (tmpVS);
+                          free (tmpVS);
+                          map *tmpC = tmp;
+                          while (tmpC != NULL)
+                            {
+                              addToMap (tmpMaps->content, tmpC->name,
+                                        tmpC->value);
+                              tmpC = tmpC->next;
+                            }
+                          freeMap (&tmp);
+                          free (tmp);
+                        }
+                    }
+                }
+            }
+
+          if (tmpIoType != NULL)
+            {
+              map *tmpContent = tmpIoType->content;
+              map *cval = NULL;
+              int hasPassed = -1;
+              while (tmpContent != NULL)
+                {
+                  if ((cval =
+                       getMap (tmpMaps->content, tmpContent->name)) == NULL)
+                    {
 #ifdef DEBUG
-	    fprintf(stderr,"addDefaultValues %s => %s\n",tmpContent->name,tmpContent->value);
-#endif
-	    if(tmpMaps->content==NULL)
-	      tmpMaps->content=createMap(tmpContent->name,tmpContent->value);
-	    else
-	      addToMap(tmpMaps->content,tmpContent->name,tmpContent->value);
-	    
-	    if(hasPassed<0 && type==0 && getMap(tmpMaps->content,"isArray")!=NULL){
-	      map* length=getMap(tmpMaps->content,"length");
-	      int i;
-	      char *tcn=strdup(tmpContent->name);
-	      for(i=1;i<atoi(length->value);i++){
+                      fprintf (stderr, "addDefaultValues %s => %s\n",
+                               tmpContent->name, tmpContent->value);
+#endif
+                      if (tmpMaps->content == NULL)
+                        tmpMaps->content =
+                          createMap (tmpContent->name, tmpContent->value);
+                      else
+                        addToMap (tmpMaps->content, tmpContent->name,
+                                  tmpContent->value);
+
+                      if (hasPassed < 0 && type == 0
+                          && getMap (tmpMaps->content, "isArray") != NULL)
+                        {
+                          map *length = getMap (tmpMaps->content, "length");
+                          int i;
+                          char *tcn = strdup (tmpContent->name);
+                          for (i = 1; i < atoi (length->value); i++)
+                            {
 #ifdef DEBUG
-		dumpMap(tmpMaps->content);
-		fprintf(stderr,"addDefaultValues %s_%d => %s\n",tcn,i,tmpContent->value);
-#endif
-		int len=strlen((char*) tcn);
-		char *tmp1=(char *)malloc((len+10)*sizeof(char));
-		sprintf(tmp1,"%s_%d",tcn,i);
+                              dumpMap (tmpMaps->content);
+                              fprintf (stderr,
+                                       "addDefaultValues %s_%d => %s\n", tcn,
+                                       i, tmpContent->value);
+#endif
+                              int len = strlen ((char *) tcn);
+                              char *tmp1 =
+                                (char *) malloc ((len + 10) * sizeof (char));
+                              sprintf (tmp1, "%s_%d", tcn, i);
 #ifdef DEBUG
-		fprintf(stderr,"addDefaultValues %s => %s\n",tmp1,tmpContent->value);
-#endif
-		addToMap(tmpMaps->content,tmp1,tmpContent->value);
-		free(tmp1);
-		hasPassed=1;
-	      }
-	      free(tcn);
-	    }
-	  }
-	  tmpContent=tmpContent->next;
-	}
+                              fprintf (stderr, "addDefaultValues %s => %s\n",
+                                       tmp1, tmpContent->value);
+#endif
+                              addToMap (tmpMaps->content, tmp1,
+                                        tmpContent->value);
+                              free (tmp1);
+                              hasPassed = 1;
+                            }
+                          free (tcn);
+                        }
+                    }
+                  tmpContent = tmpContent->next;
+                }
 #ifdef USE_MS
-	/**
+        /**
 	 * check for useMapServer presence
 	 */
-	map* tmpCheck=getMap(tmpIoType->content,"useMapServer");
-	if(tmpCheck!=NULL){
-	  // Get the default value
-	  tmpIoType=getIoTypeFromElement(tmpInputs,tmpInputs->name,NULL);
-	  tmpCheck=getMap(tmpMaps->content,"mimeType");
-	  addToMap(tmpMaps->content,"requestedMimeType",tmpCheck->value);
-	  map* cursor=tmpIoType->content;
-	  while(cursor!=NULL){
-	    addToMap(tmpMaps->content,cursor->name,cursor->value);
-	    cursor=cursor->next;
-	  }
-	  
-	  cursor=tmpInputs->content;
-	  while(cursor!=NULL){
-	    if(strcasecmp(cursor->name,"Title")==0 ||
-	       strcasecmp(cursor->name,"Abstract")==0)
-	      addToMap(tmpMaps->content,cursor->name,cursor->value);
-           cursor=cursor->next;
-	  }
-	}
-#endif
-      }
-      if(tmpMaps->content==NULL)
-	tmpMaps->content=createMap("inRequest","true");
-      else
-	addToMap(tmpMaps->content,"inRequest","true");
-
-    }
-    tmpInputs=tmpInputs->next;
-  }
+              map *tmpCheck = getMap (tmpIoType->content, "useMapServer");
+              if (tmpCheck != NULL)
+                {
+                  // Get the default value
+                  tmpIoType =
+                    getIoTypeFromElement (tmpInputs, tmpInputs->name, NULL);
+                  tmpCheck = getMap (tmpMaps->content, "mimeType");
+                  addToMap (tmpMaps->content, "requestedMimeType",
+                            tmpCheck->value);
+                  map *cursor = tmpIoType->content;
+                  while (cursor != NULL)
+                    {
+                      addToMap (tmpMaps->content, cursor->name,
+                                cursor->value);
+                      cursor = cursor->next;
+                    }
+
+                  cursor = tmpInputs->content;
+                  while (cursor != NULL)
+                    {
+                      if (strcasecmp (cursor->name, "Title") == 0 ||
+                          strcasecmp (cursor->name, "Abstract") == 0)
+                        addToMap (tmpMaps->content, cursor->name,
+                                  cursor->value);
+                      cursor = cursor->next;
+                    }
+                }
+#endif
+            }
+          if (tmpMaps->content == NULL)
+            tmpMaps->content = createMap ("inRequest", "true");
+          else
+            addToMap (tmpMaps->content, "inRequest", "true");
+
+        }
+      tmpInputs = tmpInputs->next;
+    }
   return "";
 }
@@ -2716,46 +3302,56 @@
  * Note : support only 2D bounding box.
  */
-map* parseBoundingBox(const char* value){
-  map *res=NULL;
-  if(value!=NULL){
-    char *cv,*cvp;
-    cv=strtok_r((char*) value,",",&cvp);
-    int cnt=0;
-    int icnt=0;
-    char *currentValue=NULL;
-    while(cv){
-      if(cnt<2)
-	if(currentValue!=NULL){
-	  char *finalValue=(char*)malloc((strlen(currentValue)+strlen(cv)+1)*sizeof(char));
-	  sprintf(finalValue,"%s%s",currentValue,cv);
-	  switch(cnt){
-	  case 0:
-	    res=createMap("lowerCorner",finalValue);
-	    break;
-	  case 1:
-	    addToMap(res,"upperCorner",finalValue);
-	    icnt=-1;
-	    break;
-	  }
-	  cnt++;
-	  free(currentValue);
-	  currentValue=NULL;
-	  free(finalValue);
-	}
-	else{
-	  currentValue=(char*)malloc((strlen(cv)+2)*sizeof(char));
-	  sprintf(currentValue,"%s ",cv);
-	}
-      else
-	if(cnt==2){
-	  addToMap(res,"crs",cv);
-	  cnt++;
-	}
-	else
-	  addToMap(res,"dimensions",cv);
-      icnt++;
-      cv=strtok_r(NULL,",",&cvp);
-    }
-  }
+map *
+parseBoundingBox (const char *value)
+{
+  map *res = NULL;
+  if (value != NULL)
+    {
+      char *cv, *cvp;
+      cv = strtok_r ((char *) value, ",", &cvp);
+      int cnt = 0;
+      int icnt = 0;
+      char *currentValue = NULL;
+      while (cv)
+        {
+          if (cnt < 2)
+            if (currentValue != NULL)
+              {
+                char *finalValue =
+                  (char *) malloc ((strlen (currentValue) + strlen (cv) + 1) *
+                                   sizeof (char));
+                sprintf (finalValue, "%s%s", currentValue, cv);
+                switch (cnt)
+                  {
+                  case 0:
+                    res = createMap ("lowerCorner", finalValue);
+                    break;
+                  case 1:
+                    addToMap (res, "upperCorner", finalValue);
+                    icnt = -1;
+                    break;
+                  }
+                cnt++;
+                free (currentValue);
+                currentValue = NULL;
+                free (finalValue);
+              }
+            else
+              {
+                currentValue =
+                  (char *) malloc ((strlen (cv) + 2) * sizeof (char));
+                sprintf (currentValue, "%s ", cv);
+              }
+          else if (cnt == 2)
+            {
+              addToMap (res, "crs", cv);
+              cnt++;
+            }
+          else
+            addToMap (res, "dimensions", cv);
+          icnt++;
+          cv = strtok_r (NULL, ",", &cvp);
+        }
+    }
   return res;
 }
@@ -2766,107 +3362,126 @@
  * Lower/UpperCorner nodes to a pre-existing XML node.
  */
-void printBoundingBox(xmlNsPtr ns_ows,xmlNodePtr n,map* boundingbox){
-
-  xmlNodePtr lw=NULL,uc=NULL;
-
-  map* tmp=getMap(boundingbox,"value");
-
-  tmp=getMap(boundingbox,"lowerCorner");
-  if(tmp!=NULL){
-    lw=xmlNewNode(ns_ows,BAD_CAST "LowerCorner");
-    xmlAddChild(lw,xmlNewText(BAD_CAST tmp->value));
-  }
-
-  tmp=getMap(boundingbox,"upperCorner");
-  if(tmp!=NULL){
-    uc=xmlNewNode(ns_ows,BAD_CAST "UpperCorner");
-    xmlAddChild(uc,xmlNewText(BAD_CAST tmp->value));
-  }
-
-  tmp=getMap(boundingbox,"crs");
-  if(tmp!=NULL)
-    xmlNewProp(n,BAD_CAST "crs",BAD_CAST tmp->value);
-
-  tmp=getMap(boundingbox,"dimensions");
-  if(tmp!=NULL)
-    xmlNewProp(n,BAD_CAST "dimensions",BAD_CAST tmp->value);
-
-  xmlAddChild(n,lw);
-  xmlAddChild(n,uc);
-
-}
-
-void printBoundingBoxDocument(maps* m,maps* boundingbox,FILE* file){
-  if(file==NULL)
-    rewind(stdout);
+void
+printBoundingBox (xmlNsPtr ns_ows, xmlNodePtr n, map * boundingbox)
+{
+
+  xmlNodePtr lw = NULL, uc = NULL;
+
+  map *tmp = getMap (boundingbox, "value");
+
+  tmp = getMap (boundingbox, "lowerCorner");
+  if (tmp != NULL)
+    {
+      lw = xmlNewNode (ns_ows, BAD_CAST "LowerCorner");
+      xmlAddChild (lw, xmlNewText (BAD_CAST tmp->value));
+    }
+
+  tmp = getMap (boundingbox, "upperCorner");
+  if (tmp != NULL)
+    {
+      uc = xmlNewNode (ns_ows, BAD_CAST "UpperCorner");
+      xmlAddChild (uc, xmlNewText (BAD_CAST tmp->value));
+    }
+
+  tmp = getMap (boundingbox, "crs");
+  if (tmp != NULL)
+    xmlNewProp (n, BAD_CAST "crs", BAD_CAST tmp->value);
+
+  tmp = getMap (boundingbox, "dimensions");
+  if (tmp != NULL)
+    xmlNewProp (n, BAD_CAST "dimensions", BAD_CAST tmp->value);
+
+  xmlAddChild (n, lw);
+  xmlAddChild (n, uc);
+
+}
+
+void
+printBoundingBoxDocument (maps * m, maps * boundingbox, FILE * file)
+{
+  if (file == NULL)
+    rewind (stdout);
   xmlNodePtr n;
   xmlDocPtr doc;
-  xmlNsPtr ns_ows,ns_xsi;
+  xmlNsPtr ns_ows, ns_xsi;
   xmlChar *xmlbuff;
   int buffersize;
-  char *encoding=getEncoding(m);
+  char *encoding = getEncoding (m);
   map *tmp;
-  if(file==NULL){
-    int pid=0;
-    tmp=getMapFromMaps(m,"lenv","sid");
-    if(tmp!=NULL)
-      pid=atoi(tmp->value);
-    if(pid==getpid()){
-      printf("Content-Type: text/xml; charset=%s\r\nStatus: 200 OK\r\n\r\n",encoding);
-    }
-    fflush(stdout);
-  }
-
-  doc = xmlNewDoc(BAD_CAST "1.0");
-  int owsId=zooXmlAddNs(NULL,"http://www.opengis.net/ows/1.1","ows");
-  ns_ows=usedNs[owsId];
-  n = xmlNewNode(ns_ows, BAD_CAST "BoundingBox");
-  xmlNewNs(n,BAD_CAST "http://www.opengis.net/ows/1.1",BAD_CAST "ows");
-  int xsiId=zooXmlAddNs(n,"http://www.w3.org/2001/XMLSchema-instance","xsi");
-  ns_xsi=usedNs[xsiId];
-  xmlNewNsProp(n,ns_xsi,BAD_CAST "schemaLocation",BAD_CAST "http://www.opengis.net/ows/1.1 http://schemas.opengis.net/ows/1.1.0/owsCommon.xsd");
-  map *tmp1=getMap(boundingbox->content,"value");
-  tmp=parseBoundingBox(tmp1->value);
-  printBoundingBox(ns_ows,n,tmp);
-  xmlDocSetRootElement(doc, n);
-
-  xmlDocDumpFormatMemoryEnc(doc, &xmlbuff, &buffersize, encoding, 1);
-  if(file==NULL)
-    printf("%s",xmlbuff);
-  else{
-    fprintf(file,"%s",xmlbuff);
-  }
-
-  if(tmp!=NULL){
-    freeMap(&tmp);
-    free(tmp);
-  }
-  xmlFree(xmlbuff);
-  xmlFreeDoc(doc);
-  xmlCleanupParser();
-  zooXmlCleanupNs();
-  
-}
-
-
-char* getMd5(char* url){
+  if (file == NULL)
+    {
+      int pid = 0;
+      tmp = getMapFromMaps (m, "lenv", "sid");
+      if (tmp != NULL)
+        pid = atoi (tmp->value);
+      if (pid == getpid ())
+        {
+          printf
+            ("Content-Type: text/xml; charset=%s\r\nStatus: 200 OK\r\n\r\n",
+             encoding);
+        }
+      fflush (stdout);
+    }
+
+  doc = xmlNewDoc (BAD_CAST "1.0");
+  int owsId = zooXmlAddNs (NULL, "http://www.opengis.net/ows/1.1", "ows");
+  ns_ows = usedNs[owsId];
+  n = xmlNewNode (ns_ows, BAD_CAST "BoundingBox");
+  xmlNewNs (n, BAD_CAST "http://www.opengis.net/ows/1.1", BAD_CAST "ows");
+  int xsiId =
+    zooXmlAddNs (n, "http://www.w3.org/2001/XMLSchema-instance", "xsi");
+  ns_xsi = usedNs[xsiId];
+  xmlNewNsProp (n, ns_xsi, BAD_CAST "schemaLocation",
+                BAD_CAST
+                "http://www.opengis.net/ows/1.1 http://schemas.opengis.net/ows/1.1.0/owsCommon.xsd");
+  map *tmp1 = getMap (boundingbox->content, "value");
+  tmp = parseBoundingBox (tmp1->value);
+  printBoundingBox (ns_ows, n, tmp);
+  xmlDocSetRootElement (doc, n);
+
+  xmlDocDumpFormatMemoryEnc (doc, &xmlbuff, &buffersize, encoding, 1);
+  if (file == NULL)
+    printf ("%s", xmlbuff);
+  else
+    {
+      fprintf (file, "%s", xmlbuff);
+    }
+
+  if (tmp != NULL)
+    {
+      freeMap (&tmp);
+      free (tmp);
+    }
+  xmlFree (xmlbuff);
+  xmlFreeDoc (doc);
+  xmlCleanupParser ();
+  zooXmlCleanupNs ();
+
+}
+
+
+char *
+getMd5 (char *url)
+{
   EVP_MD_CTX md5ctx;
-  char* fresult=(char*)malloc((EVP_MAX_MD_SIZE+1)*sizeof(char));
+  char *fresult = (char *) malloc ((EVP_MAX_MD_SIZE + 1) * sizeof (char));
   unsigned char result[EVP_MAX_MD_SIZE];
   unsigned int len;
-  EVP_DigestInit(&md5ctx, EVP_md5());
-  EVP_DigestUpdate(&md5ctx, url, strlen(url));
-  EVP_DigestFinal_ex(&md5ctx,result,&len);
-  EVP_MD_CTX_cleanup(&md5ctx);
+  EVP_DigestInit (&md5ctx, EVP_md5 ());
+  EVP_DigestUpdate (&md5ctx, url, strlen (url));
+  EVP_DigestFinal_ex (&md5ctx, result, &len);
+  EVP_MD_CTX_cleanup (&md5ctx);
   int i;
-  for(i = 0; i < len; i++){
-    if(i>0){
-      char *tmp=strdup(fresult);
-      sprintf(fresult,"%s%02x", tmp,result[i]);
-      free(tmp);
-    }
-    else
-      sprintf(fresult,"%02x",result[i]);
-  }
+  for (i = 0; i < len; i++)
+    {
+      if (i > 0)
+        {
+          char *tmp = strdup (fresult);
+          sprintf (fresult, "%s%02x", tmp, result[i]);
+          free (tmp);
+        }
+      else
+        sprintf (fresult, "%02x", result[i]);
+    }
   return fresult;
 }
@@ -2875,103 +3490,134 @@
  * Cache a file for a given request
  */
-void addToCache(maps* conf,char* request,char* content,char* mimeType,int length){
-  map* tmp=getMapFromMaps(conf,"main","cacheDir");
-  if(tmp!=NULL){
-    char* md5str=getMd5(request);
-    char* fname=(char*)malloc(sizeof(char)*(strlen(tmp->value)+strlen(md5str)+6));
-    sprintf(fname,"%s/%s.zca",tmp->value,md5str);
+void
+addToCache (maps * conf, char *request, char *content, char *mimeType,
+            int length)
+{
+  map *tmp = getMapFromMaps (conf, "main", "cacheDir");
+  if (tmp != NULL)
+    {
+      char *md5str = getMd5 (request);
+      char *fname =
+        (char *) malloc (sizeof (char) *
+                         (strlen (tmp->value) + strlen (md5str) + 6));
+      sprintf (fname, "%s/%s.zca", tmp->value, md5str);
 #ifdef DEBUG
-    fprintf(stderr,"Cache list : %s\n",fname);
-    fflush(stderr);
-#endif
-    FILE* fo=fopen(fname,"w+");
-    if(fo==NULL){
-      fprintf (stderr, "Failed to open %s for writting: %s\n",fname, strerror(errno));
-      return;
-    }
-    fwrite(content,sizeof(char),length,fo);
-    fclose(fo);
-
-    sprintf(fname,"%s/%s.zcm",tmp->value,md5str);
-    fo=fopen(fname,"w+");
+      fprintf (stderr, "Cache list : %s\n", fname);
+      fflush (stderr);
+#endif
+      FILE *fo = fopen (fname, "w+");
+      if (fo == NULL)
+        {
+          fprintf (stderr, "Failed to open %s for writting: %s\n", fname,
+                   strerror (errno));
+          return;
+        }
+      fwrite (content, sizeof (char), length, fo);
+      fclose (fo);
+
+      sprintf (fname, "%s/%s.zcm", tmp->value, md5str);
+      fo = fopen (fname, "w+");
 #ifdef DEBUG
-    fprintf(stderr,"MIMETYPE: %s\n",mimeType);
-#endif
-    fwrite(mimeType,sizeof(char),strlen(mimeType),fo);
-    fclose(fo);
-
-    free(md5str);
-    free(fname);
-  }
-}
-
-char* isInCache(maps* conf,char* request){
-  map* tmpM=getMapFromMaps(conf,"main","cacheDir");
-  if(tmpM!=NULL){
-    char* md5str=getMd5(request);
+      fprintf (stderr, "MIMETYPE: %s\n", mimeType);
+#endif
+      fwrite (mimeType, sizeof (char), strlen (mimeType), fo);
+      fclose (fo);
+
+      free (md5str);
+      free (fname);
+    }
+}
+
+char *
+isInCache (maps * conf, char *request)
+{
+  map *tmpM = getMapFromMaps (conf, "main", "cacheDir");
+  if (tmpM != NULL)
+    {
+      char *md5str = getMd5 (request);
 #ifdef DEBUG
-    fprintf(stderr,"MD5STR : (%s)\n\n",md5str);
-#endif
-    char* fname=(char*)malloc(sizeof(char)*(strlen(tmpM->value)+strlen(md5str)+6));
-    sprintf(fname,"%s/%s.zca",tmpM->value,md5str);
-    struct stat f_status;
-    int s=stat(fname, &f_status);
-    if(s==0 && f_status.st_size>0){
-      free(md5str);
-      return fname;
-    }
-    free(md5str);
-    free(fname);
-  }
+      fprintf (stderr, "MD5STR : (%s)\n\n", md5str);
+#endif
+      char *fname =
+        (char *) malloc (sizeof (char) *
+                         (strlen (tmpM->value) + strlen (md5str) + 6));
+      sprintf (fname, "%s/%s.zca", tmpM->value, md5str);
+      struct stat f_status;
+      int s = stat (fname, &f_status);
+      if (s == 0 && f_status.st_size > 0)
+        {
+          free (md5str);
+          return fname;
+        }
+      free (md5str);
+      free (fname);
+    }
   return NULL;
 }
 
-int runHttpRequests(maps** m,maps** inputs,HINTERNET* hInternet){
-  if(hInternet->nb>0){
-    processDownloads(hInternet);
-    maps* content=*inputs;
-    map* tmp1;
-    int index=0;
-    while(content!=NULL){
-      if((tmp1=getMap(content->content,"href")) || 
-	 (tmp1=getMap(content->content,"xlink:href"))){
-	if(getMap(content->content,"isCached")==NULL){
-	  char* fcontent;
-	  char *mimeType=NULL;
-	  int fsize=0;
-
-	  fcontent=(char*)malloc((hInternet->ihandle[index].nDataLen+1)*sizeof(char));
-	  if(fcontent == NULL){
-	    return errorException(*m, _("Unable to allocate memory."), "InternalError",NULL);
-	  }
-	  size_t dwRead;
-	  InternetReadFile(hInternet->ihandle[index], 
-			   (LPVOID)fcontent, 
-			   hInternet->ihandle[index].nDataLen, 
-			   &dwRead);
-	  fcontent[hInternet->ihandle[index].nDataLen]=0;
-	  fsize=hInternet->ihandle[index].nDataLen;
-	  mimeType=strdup((char*)hInternet->ihandle[index].mimeType);
-	  
-	  map* tmpMap=getMapOrFill(&content->content,"value","");
-	  free(tmpMap->value);
-	  tmpMap->value=(char*)malloc((fsize+1)*sizeof(char));
-	  if(tmpMap->value==NULL){
-	    return errorException(*m, _("Unable to allocate memory."), "InternalError",NULL);
-	  }
-	  memcpy(tmpMap->value,fcontent,(fsize+1)*sizeof(char));
-	  
-	  char ltmp1[256];
-	  sprintf(ltmp1,"%d",fsize);
-	  addToMap(content->content,"size",ltmp1);
-	  addToCache(*m,tmp1->value,fcontent,mimeType,fsize);
-	  free(fcontent);
-	  free(mimeType);
-	}
-	index++;
-      }
-      content=content->next;
-    }
-  }
+int
+runHttpRequests (maps ** m, maps ** inputs, HINTERNET * hInternet)
+{
+  if (hInternet->nb > 0)
+    {
+      processDownloads (hInternet);
+      maps *content = *inputs;
+      map *tmp1;
+      int index = 0;
+      while (content != NULL)
+        {
+          if ((tmp1 = getMap (content->content, "href")) ||
+              (tmp1 = getMap (content->content, "xlink:href")))
+            {
+              if (getMap (content->content, "isCached") == NULL)
+                {
+                  char *fcontent;
+                  char *mimeType = NULL;
+                  int fsize = 0;
+
+                  fcontent =
+                    (char *) malloc ((hInternet->ihandle[index].nDataLen + 1)
+                                     * sizeof (char));
+                  if (fcontent == NULL)
+                    {
+                      return errorException (*m,
+                                             _("Unable to allocate memory."),
+                                             "InternalError", NULL);
+                    }
+                  size_t dwRead;
+                  InternetReadFile (hInternet->ihandle[index],
+                                    (LPVOID) fcontent,
+                                    hInternet->ihandle[index].nDataLen,
+                                    &dwRead);
+                  fcontent[hInternet->ihandle[index].nDataLen] = 0;
+                  fsize = hInternet->ihandle[index].nDataLen;
+                  mimeType =
+                    strdup ((char *) hInternet->ihandle[index].mimeType);
+
+                  map *tmpMap = getMapOrFill (&content->content, "value", "");
+                  free (tmpMap->value);
+                  tmpMap->value =
+                    (char *) malloc ((fsize + 1) * sizeof (char));
+                  if (tmpMap->value == NULL)
+                    {
+                      return errorException (*m,
+                                             _("Unable to allocate memory."),
+                                             "InternalError", NULL);
+                    }
+                  memcpy (tmpMap->value, fcontent,
+                          (fsize + 1) * sizeof (char));
+
+                  char ltmp1[256];
+                  sprintf (ltmp1, "%d", fsize);
+                  addToMap (content->content, "size", ltmp1);
+                  addToCache (*m, tmp1->value, fcontent, mimeType, fsize);
+                  free (fcontent);
+                  free (mimeType);
+                }
+              index++;
+            }
+          content = content->next;
+        }
+    }
 }
 
